;****************************************************
;             MCP3202 ̿ A/D ȯ           *
;****************************************************
;
CS	BIT	P1.0
DIN	BIT	P1.1
DOUT	BIT	P1.2
CLK	BIT	P1.3
SEG_10	BIT	P2.4
SEG_01	BIT	P2.5
;
	ORG     0000H		; α׷ 
;
START:
	CALL	MCP3202         ; ADC ȯ 
	MOV	R4,#00H		; ADC_TBL ʱּҸ 00H 
	MOV	DPTR,#ADC_TBL	; ADC_TBL ʱⰪ ּ
COMP_ADC:
	CLR	A		; ADC_TBL о 
	MOVC	A,@A+DPTR	; ADC_TBL High Byte б
	MOV	R3,A
	INC	DPTR
	CLR	A
	MOVC	A,@A+DPTR	; ADC_TBL Low Byte б
	MOV	R2,A
	CALL    COMPARE
;
	JC	DISPLAY		; ADC < ADC_TBL ?
	INC	R4
	INC	DPTR
	JMP	COMP_ADC
;
MCP3202: 			;  д ƾ(MCP3202-->8051)
	CLR	CLK		; ʱȭ
	CLR	DIN		; ʱȭ
;
	CLR	CS		; chip select
        SETB    DIN		; Start Bit
	SETB	CLK
	CLR	CLK
;
	SETB	DIN		; SGL/DIFF=1, Single ended mode
	SETB	CLK
	CLR	CLK
;
	CLR	DIN		; ODD/SIGN=0, CH0 
	SETB	CLK
	CLR	CLK
;
	SETB	DIN		; MSBF=1, MSB First 
	SETB	CLK
	CLR	CLK
;
	CLR	DIN		; Null Bit
	SETB	CLK
	CLR	CLK
;
	MOV     R4,#04H		; Ÿֵ̹  ķ ADȯ ( 4Ʈ)
	CLR	A
RD_LOOP4:
	SETB	CLK		; CLK=H
	MOV	C,DOUT		; Input One Bit of Data
        CLR	CLK		; CLK=L
        RLC	A		; Shift Right with Carry
        DJNZ    R4,RD_LOOP4	; Check # of data(=4)
	MOV	R1,A		; R1 = 4 Bit Data
;
	MOV     R4,#08H		; Ÿֵ̹  ķ ADȯ (8Ʈ)
	CLR	A
RD_LOOP8:
	SETB	CLK		; CLK=H
	MOV	C,DOUT		; Input One Bit of Data
        CLR	CLK		; CLK=L
        RLC	A		; Shift Right with Carry
        DJNZ    R4,RD_LOOP8	; Check # of data(=8)
	MOV	R0,A		; R0 = 8 Bit Data
;
	SETB	CS
	SETB	CLK
	RET
;
; 16-Bit  
; CY=1̸ X<Y, CY=0̸ X>Y
;
COMPARE:
	MOV	A,R0		; X Ʈ A 
	CLR	C		; CY=0
	SUBB	A,R2		; R0 - R2
	MOV	A,R1		; X Ʈ A 
	SUBB	A,R3		; R1 - R3
	RET
;
DISPLAY:
	MOV	A,R4
	MOV	DPTR,#DISP_TBL	; ʱ ǥð ּ
	MOVC	A,@A+DPTR	; ǥð 
	MOV	R5,A		; R5 ǥð Ͻ 
	ORL	A,#0F0H
	MOV	P2,A		; 1 ȯ ǥ
	CLR	SEG_01		;  ġ
	SETB	SEG_01
	MOV	A,R5
	SWAP	A
	ORL	A,#0F0H
	MOV	P2,A		; 10 ȯ ǥ
	CLR	SEG_10		;  ġ
	SETB	SEG_10
	JMP	START
;
ADC_TBL:			; ADC ȯ
	DW	0028H,007AH,00CCH,011EH,0170H
	DW	01C2H,0214H,0266H,02B8H,030AH
	DW	035CH,03AEH,03FFH,0451H,04A3H
	DW	04F5H,0547H,0599H,05EBH,063DH
	DW	068FH,06E1H,0733H,0785H,07D7H
	DW	0828H,087AH,08CCH,091EH,0970H
	DW	09C2H,0A14H,0A66H,0AB8H,0B0AH
	DW	0B5CH,0BAEH,0BFFH,0C51H,0CA3H
	DW	0CF5H,0D47H,0D99H,0DEBH,0E3DH
	DW	0E8FH,0EE1H,0F33H,0F85H,0FD7H
	DW	1000H
;
DISP_TBL:
	DB	00H,01H,02H,03H,04H,05H,06H,07H,08H,09H
	DB	10H,11H,12H,13H,14H,15H,16H,17H,18H,19H
	DB	20H,21H,22H,23H,24H,25H,26H,27H,28H,29H
	DB	30H,31H,32H,33H,34H,35H,36H,37H,38H,39H
	DB	40H,41H,42H,43H,44H,45H,46H,47H,48H,49H
	DB	50H
        END			; α׷ 
