;****************************************************
;                  Ʈ̼                     *
;****************************************************
;
LED_R	BIT	P3.0		;  LED
LED_C	BIT	P3.1		;  LED
LED_L	BIT	P3.2		;  LED
;
MOL1	BIT	P3.4		; ʸ
MOL2	BIT	P3.3		; ʸ
MOR1	BIT	P3.7		; ʸ
MOR2	BIT	P3.5		; ʸ
;
BUZZER	BIT	P1.0		; 
;
TRAN_R	BIT	P1.2		;  ߱
TRAN_C	BIT	P1.3		;  ߱
TRAN_L	BIT	P1.4		;  ߱
;
RECV_R	BIT	P1.5		;  
RECV_C	BIT	P1.6		;  
RECV_L	BIT	P1.7		;  
;
	ORG   	0000H		; α׷ 
	CLR	MOL1		;  
	CLR	MOL2
	CLR	MOR1
	CLR	MOR2
;
	CLR	TRAN_R		;   off
	CLR	TRAN_C
	CLR	TRAN_L
;
	SETB	LED_R		;  LED off
	SETB	LED_C
	SETB	LED_L
;
	SETB	BUZZER		;  off
;
	MOV	R0,#03H		; LED on & off(3ȸ)
START:	CLR	BUZZER		;  on
	CLR	LED_R		;  LED on
	CLR	LED_C
	CLR	LED_L
	CALL	DELAY0
;
	SETB	BUZZER		;  off
	SETB	LED_R		;  LED off
	SETB	LED_C
	SETB	LED_L
	CALL	DELAY0
	DJNZ	R0,START
;
	MOV	R1,#05H		;  = 05H
;
MAIN:	
	SETB	TRAN_R		; ߱ on
	SETB	TRAN_C
	SETB	TRAN_L
	CALL	DELAY1
;
	MOV	A,P1		;  
	CLR	TRAN_R		; ߱ off
	CLR	TRAN_C
	CLR	TRAN_L
;
	RR	A		;  Ʈ ̵
	RR	A
	RR	A
	RR	A
	RR	A
	CPL	A		;   (=1, =0)
	ANL	A,#00000111B	; Ʈ P1.7~P1.3 ũ
;
CONTROL:			;    
	CJNE	A,#00H,MOD1	;   000 
	JMP	CON0
MOD1:	CJNE	A,#01H,MOD2	;   001 
	JMP	CON1
MOD2:	CJNE	A,#02H,MOD3	;   010 
	JMP	CON2
MOD3:	CJNE	A,#03H,MOD4	;   011 
	JMP	CON3
MOD4:	CJNE	A,#04H,MOD5	;   100 
	JMP	CON4
MOD5:	CJNE	A,#05H,MOD6	;   101 
	JMP	CON5
MOD6:	CJNE	A,#06H,MOD7	;   110 
	JMP	CON6
MOD7:	JMP	CON7		;   111 
;
CON0:				;  ⿡  ȸ, ȸ
	SETB	LED_L		;  LED off
	SETB	LED_C		;  LED off
	SETB	LED_R		;  LED off
;
        MOV     A,R1
        JMP     CONTROL
;
CON1:				; ϸ鼭  ȸ
	SETB	LED_L		;  LED off
	SETB	LED_C		;  LED off
	CLR	LED_R		;  LED on
;
	CLR	MOL1		; ʸ 
	SETB	MOL2
	CLR	MOR1		; ʸ 
	SETB	MOR2
	CALL	DELAY2
	SETB	MOL1		; ʸ 
	CLR	MOL2
	CALL	DELAY3
	CLR	MOL1		; ʸ 
	CLR	MOR2		; ʸ 
	MOV	R1,A
	JMP	MAIN
;
CON2:                           ;  
	SETB	LED_L		;  LED off
	CLR	LED_C		;  LED on
	SETB	LED_R		;  LED off
;
	SETB	MOL1		; ʸ 
	CLR	MOL2
	CLR	MOR1		; ʸ 
	SETB	MOR2
	CALL	DELAY2
	CLR	MOL1		; ʸ 
	CLR	MOR2		; ʸ 
	JMP	MAIN
;
CON3:				; ϸ鼭 ȸ
	SETB	LED_L		;  LED off
	CLR	LED_C		;  LED on
	CLR	LED_R		;  LED on
;
	CLR	MOL1		; ʸ 
	CLR	MOL2
	CLR	MOR1		; ʸ 
	SETB	MOR2
	CALL	DELAY2
	SETB	MOL1		; ʸ 
	CLR	MOL2
	CALL	DELAY3
	CLR	MOL1		; ʸ 
	CLR	MOR2		; ʸ 
	MOV	R1,A
	JMP	MAIN
;
CON4:				; ϸ鼭  ȸ
	CLR	LED_L		;  LED on
	SETB	LED_C		;  LED off
	SETB	LED_R		;  LED off
;
	SETB	MOL1		; ʸ 
	CLR	MOL2
	SETB	MOR1		; ʸ 
	CLR	MOR2
	CALL	DELAY2
	CLR	MOR1		; ʸ 
	SETB	MOR2
	CALL	DELAY3
	CLR	MOL1		; ʸ 
	CLR	MOR2		; ʸ 
	MOV	R1,A
	JMP	MAIN
;
CON5:				;  
	CLR	LED_L		;  LED on
	SETB	LED_C		;  LED off
	CLR	LED_R		;  LED on
;
	SETB	MOL1		; ʸ 
	CLR	MOL2
	CLR	MOR1		; ʸ 
	SETB	MOR2
	CALL	DELAY2
	CLR	MOL1		; ʸ 
	CLR	MOR2		; ʸ 
	CALL	DELAY3
	JMP	MAIN
;
CON6:				; ϸ鼭 ȸ
	CLR	LED_L		;  LED on
	CLR	LED_C		;  LED on
	SETB	LED_R		;  LED off
;
	SETB	MOL1		; ʸ 
	CLR	MOL2
	CLR	MOR1		; ʸ 
	CLR	MOR2
	CALL	DELAY2
	CLR	MOR1		; ʸ 
	SETB	MOR2
	CALL	DELAY3
	CLR	MOL1		; ʸ 
	CLR	MOR2		; ʸ 
	MOV	R1,A
	JMP	MAIN
;
CON7:				;  ⿡  ȸ, ȸ
	CLR	LED_L		;  LED on
	CLR	LED_C		;  LED on
	CLR	LED_R		;  LED on
;
        MOV     A,R1
        JMP     CONTROL
;
DELAY0:				;  
	MOV	R2,#160
DLY1:	MOV	R3,#00H
DLY2:	NOP
	DJNZ	R3,DLY2
	DJNZ	R2,DLY1
	RET
;
DELAY1:				;  
        MOV	R2,#50
DLY3:	NOP
	DJNZ	R2,DLY3
	RET
;
DELAY2:				;   
        MOV	R2,#110
DLY4:	NOP
	DJNZ	R2,DLY4
	RET
;
DELAY3:				;   
        MOV	R2,#55
DLY5:	NOP
	DJNZ	R2,DLY5
	RET
	END			; α׷ 
