//  Ʈ̼

#include <reg51.h>

sbit LED_R=P3^0;	//  LED
sbit LED_C=P3^1;	//  LED
sbit LED_L=P3^2;	//  LED

sbit MOL1=P3^4;		//  DC 
sbit MOL2=P3^3;		//  DC 
sbit MOR1=P3^7;		//  DC 
sbit MOR2=P3^5;		//  DC 

sbit BUZZER=P1^0;	// 

sbit TRAN_R=P1^2;	//  ܼ ߱ 
sbit TRAN_C=P1^3;	//  ܼ ߱ 
sbit TRAN_L=P1^4;	//  ܼ ߱ 

sbit RECV_R=P1^5;	//  ܼ  
sbit RECV_C=P1^6;	//  ܼ  
sbit RECV_L=P1^7;	//  ܼ  

void delay(int i)    	// ð  Լ
{
	while(i--);
}

void main(void)           
{  
	unsigned int i;
	unsigned char sensor, prev_data;

	MOL1=0; MOL2=0;				//  
	MOR1=0; MOR2=0;
	TRAN_L=0; TRAN_C=0; TRAN_R=0;		//   off	
	LED_L=1; LED_C=1; LED_R=1;   		//  LED off
	BUZZER=1;				//  off
   
	for (i=0; i<3; i++) {			//  ΰ   LED 3ȸ on/off
		BUZZER=0;			//  on
		LED_L=0; LED_C=0; LED_R=0;	// LED on
		delay(10000);
		BUZZER=1;			//  off
		LED_L=1; LED_C=1; LED_R=1;	// LED off
		delay(10000);
	}
	prev_data=0x05;				//  0x05

	do {
		TRAN_L=1; TRAN_C=1; TRAN_R=1;	// ߱  on
		delay(20);
		sensor=P1;			//    
		TRAN_L=0; TRAN_C=0; TRAN_R=0;	// ߱  off
		sensor >>= 5;			//   5Ʈ  Ʈ
		sensor=~sensor;			//  (  = 1,   = 0)
		sensor &= 0x07;			//  3Ʈ   0 

		if (sensor==0x00) {			//   
			LED_L=1; LED_C=1; LED_R=1;	//  LED off
			sensor=prev_data;
		}

		if (sensor==0x07) {			//   
			LED_L=0; LED_C=0; LED_R=0;	//  LED on
			sensor=prev_data;
		}

		switch(sensor) {

//			case 0x00:				//  ⿡  ȸ, ȸ

			case 0x01:				// ϸ鼭  ȸ
				LED_L=1; LED_C=1; LED_R=0;	// LED on/off
				MOL1=0; MOL2=1;			//   
				MOR1=0; MOR2=1;			//   
				delay(30);
				MOL1=1; MOL2=0;			//   
				delay(15);
				MOL1=0; MOR2=0;			// ¿ 
				prev_data=sensor;
				break;

			case 0x02:				//  
				LED_L=1; LED_C=0; LED_R=1;	// LED on/off
				MOL1=1; MOL2=0;			//   
				MOR1=0; MOR2=1;			//   
				delay(30);
				MOL1=0; MOR2=0;			// ¿  
				break;

			case 0x03:				// ϸ鼭 ȸ
				LED_L=1; LED_C=0; LED_R=0;	// LED on/off           
				MOL1=0; MOL2=0;			//   
				MOR1=0; MOR2=1;			//   
				delay(30);
				MOL1=1; MOL2=0;			//  
				delay(15);
				MOL1=0; MOR2=0;			// ¿  
				prev_data=sensor;
				break;

			case 0x04:				// ϸ鼭  ȸ
				LED_L=0; LED_C=1; LED_R=1;	// LED on/off
				MOL1=1; MOL2=0;			//   
				MOR1=1; MOR2=0;			//   
				delay(30);
				MOR1=0; MOR2=1;			//   
				delay(15);
				MOL1=0; MOR2=0;			// ¿  
				prev_data=sensor;
				break;

			case 0x05:				//  
				LED_L=0; LED_C=1; LED_R=0;	// LED on/off
				MOL1=1; MOL2=0;			//   
				MOR1=0; MOR2=1;			//   
				delay(30);
				MOL1=0; MOR2=0;			// ¿  
				delay(15);
				break;

			case 0x06:				// ϸ鼭 ȸ
				LED_L=0; LED_C=0; LED_R=1;	// LED on/off
				MOL1=1; MOL2=0;			//   
				MOR1=0; MOR2=0;			//   
				delay(30);
				MOR1=0; MOR2=1;			//   
				delay(15);
				MOL1=0; MOR2=0;			// ¿  
				prev_data=sensor;
				break;

//			case 0x07:				//  ⿡  ȸ, ȸ

			default:				// case ̿   
				break;
		}
	} while(1);
}
