;****************************************************
;            ͷƮ ̿  ð          *
;****************************************************
;
DISPBUF		EQU     30H     	; 6 Ʈ
SCANCNTR	EQU     36H 
ONECNT		EQU     37H
HOUR		EQU     38H
MINUTE		EQU     39H
SECOND		EQU     3AH
AMPM		EQU     3BH
DAY		EQU     3CH
;
	ORG	0000H			; α׷ 
	JMP	START
	ORG	0BH			; ͷƮ 
	JMP	TIMERINT
;
START:
	MOV	SP,#70H
	MOV	SCANCNTR,#0		; SCAN ƾ  ī
	MOV	ONECNT,#250		; 250 x 4000us = 1sec
	MOV	DAY,#10111111B		; ۽ð Sunday
	MOV     P2,#10111111B           ; Day Display
	MOV	AMPM,#00H		; AM
	CLR	P3.5			; AM Display
	SETB	P3.6
	MOV	HOUR,#12H		; 12:00:00
	MOV	MINUTE,#00H
	MOV	SECOND,#00H
;
	MOV	TMOD,#00000001B		; Ÿ̸ 0,  1
	MOV	TH0,#0F0H  		; (65536-4000)=F060H
	MOV	TL0,#69H
	MOV	IE,#10000010B		; ͷƮ ο̺
	SETB	TR0			; Ÿ̸ 0 
;
;****************************************************
;	             Main Program                   *
;****************************************************
;
MAIN:
	CALL	CONVERT
	JB	P3.0,MINT_KEY		;   Ű ԷµǾ ˻
	MOV	SECOND,#0		; Ű ԷµǾ ʴ 00 
	CALL	DELAY			; Debounce Ͽ 
	JNB	P3.0,$
;
MINT_KEY:
	JB	P3.1,HOUR_KEY		;   Ű ԷµǾ ˻
	MOV	A,MINUTE		; ԷµǾ  +1 
	ADD	A,#1
	DA	A
	MOV	MINUTE,A
	CJNE	A,#60H,NOT_M
	MOV	MINUTE,#0
NOT_M:
	CALL	DELAY           	; Debounce Ͽ 
	JNB	P3.1,$
;
HOUR_KEY:
	JB	P3.2,AMPM_KEY		;   Ű ԷµǾ ˻
	MOV	A,HOUR			; ԷµǾ ø +1 
	ADD	A,#1
	DA	A
	MOV	HOUR,A
	CJNE	A,#13H,NOT_H
	MOV	HOUR,#1
NOT_H:
	CALL	DELAY			; Debounce Ͽ 
	JNB	P3.2,$
;
AMPM_KEY:
	JB	P3.3,DAY_KEY		; /  Ű ԷµǾ ˻
	MOV	A,AMPM			; AM=00H, PM=01H
	CJNE	A,#00H,AM_DISP
	SETB	P3.5			; PM Display
	CLR	P3.6
	MOV	AMPM,#01H
	JMP	CONT3
;
AM_DISP:
	CLR	P3.5			; AM Display
	SETB	P3.6
	MOV	AMPM,#00H
CONT3:
	CALL	DELAY			; Debounce Ͽ 
	JNB	P3.3,$
;
DAY_KEY:
	JB	P3.4,MAIN		;   Ű ԷµǾ ˻
	MOV	A,DAY			; ԷµǾ  
	RR	A
	MOV	DAY,A
	CJNE	A,#01111111B,CONT4
	MOV	DAY,#10111111B
CONT4:
	MOV	A,DAY
	MOV	P2,A
;
	CALL	DELAY			; Debounce Ͽ 
	JNB	P3.4,$
	JMP	MAIN
;
;****************************************************
;	 TIMER 0 Interrupt Service Routine          *
;****************************************************
;
TIMERINT:
	MOV	TH0,#0F0H		; ͷƮ ð : 4000ms
	MOV	TL0,#69H
	PUSH	ACC
	PUSH	PSW
	SETB	RS0             	; ũ 1 
	CLR	RS1
	DJNZ	ONECNT,NOTSEC		; ͷƮ 250 Դ°?
	MOV	ONECNT,#250		;  1ʰ  ̹Ƿ
	CALL	CLOCK			; , , ø ٽ 
NOTSEC:
	CALL	SCAN			; , , ø 7-׸Ʈ ǥ
	POP	PSW
	POP	ACC
	RETI
;
;****************************************************
;		   Display Scan Routine             *
;****************************************************
;
SCAN:					; ǥÿ , , ð 
	MOV	R0,#SCANCNTR		; 7-׸Ʈ Ÿ ƾ
	INC	@R0
	CJNE	@R0,#6,NOTOVER
	MOV	@R0,#0
NOTOVER:
	MOV	A,@R0
	ADD	A,#DISPBUF
	MOV	R1,A
	MOV	A,@R0
	SWAP	A
	ORL	A,@R1
	MOV	P1,A
	RET
;
;****************************************************
;            Time Adjustment Routine                *
;****************************************************
;
CLOCK:
	MOV	A,SECOND		; ͷƮ 250  1ʰ 
	ADD	A,#1			; (SECOND) +1 
	DA	A
	MOV	SECOND,A
	CJNE	A,#60H,NOTYET		; 60ʰ Ǿ°?
	MOV	SECOND,#0		; 60ʸ ʴ 0
;
	MOV	A,MINUTE		; (MINUTE) +1
	ADD	A,#1
	DA	A
	MOV	MINUTE,A
	CJNE	A,#60H,NOTYET		; 60 Ǿ°?
	MOV	MINUTE,#0		; 60 Ǿ  0
;
	MOV	A,HOUR			; ð(HOUR) +1
	ADD	A,#1
	DA	A
	MOV	HOUR,A
	CJNE	A,#12H,CHK_13		; 12ð Ǿ°?
	JMP	CHK_AMPM
;
CHK_13:
	CJNE	A,#13H,NOTYET		; 13ð Ǿ°?
	MOV	HOUR,#1			; ø 1
	JMP	NOTYET
;
CHK_AMPM:
	MOV	A,AMPM			; AM=00H, PM=01H
	CJNE	A,#00H,DISP_AM
	SETB	P3.5			; PM Display
	CLR	P3.6
	MOV	AMPM,#01H
	JMP	NOTYET
DISP_AM:
	CLR	P3.5			; AM Display
	SETB	P3.6
	MOV	AMPM,#00H
;
	MOV	A,DAY			; ̸  
	RR	A
	MOV	DAY,A
	CJNE	A,#01111111B,DAY_DISP	; Ͽΰ?
	MOV	DAY,#10111111B
DAY_DISP:
	MOV	A,DAY
	MOV	P2,A
;
NOTYET:
	RET
;
;****************************************************
;              Time Converting Routine               *
;****************************************************
;
CONVERT:
	MOV	R1,#DISPBUF		; ʿ  ͸ ǥÿ
	MOV	A,SECOND		; (DISPBUF+0) (DISPBUF+1)
	MOV	B,#10H			;  10 A, 1 B 
	DIV	AB
	MOV	@R1,B			; 1 (DISPBUF+0) 
	INC	R1
	MOV	@R1,A			; 10 (DISPBUF+1) 
	INC	R1
	MOV	A,MINUTE		; п  ͸ ǥÿ
	MOV	B,#10H			; (DISPBUF+2) (DISPBUF+3)
	DIV	AB
	MOV	@R1,B
	INC	R1
	MOV	@R1,A
	INC	R1
	MOV	A,HOUR			; ÿ  ͸ ǥÿ
	MOV	B,#10H			; (DISPBUF+4) (DISPBUF+5)
	DIV	AB
	MOV	@R1,B
	INC	R1
	MOV	@R1,A
	RET
;
;****************************************************
;                  Delay Routine                    *
;		Delay Time = 20 msec                *
;****************************************************
;
DELAY:					; ƾ
	MOV	R6,#66
DLY1:	MOV	R7,#100
DLY2:	NOP
	DJNZ	R7,DLY2
	DJNZ	R6,DLY1
	RET
	END				; α׷ 
