// HS1101 ̿ 

#include <reg51.h>

sbit unit_10=P1^4;	// 4511 Ĩ ο̺(10 )
sbit unit_01=P1^5;	// 4511 Ĩ ο̺(1 )

unsigned char count;

code unsigned int hum_table[]={0x1CF1,0x1CDF,0x1CCE,0x1CBC,0x1CAB,
			0x1C9B,0x1C8A,0x1C7A,0x1C6A,0x1C5A,
			0x1C4B,0x1C3B,0x1C2C,0x1C1E,0x1C0F,
			0x1C00,0x1BF2,0x1BE4,0x1BD6,0x1BC8,
			0x1BBB,0x1BAD,0x1BA0,0x1B92,0x1B85,
			0x1B78,0x1B6B,0x1B5F,0x1B52,0x1B45,
			0x1B39,0x1B2C,0x1B20,0x1B14,0x1B08,
			0x1AFB,0x1AEF,0x1AE3,0x1AD7,0x1ACB,
			0x1ABF,0x1AB3,0x1AA7,0x1A9B,0x1A8F,
			0x1A84,0x1A78,0x1A6C,0x1A60,0x1A54,
			0x1A48,0x1A3C,0x1A30,0x1A24,0x1A18,
			0x1A0B,0x19FF,0x19F3,0x19E7,0x19DA,
			0x19CE,0x19C1,0x19B5,0x19A8,0x199B,
			0x198E,0x1981,0x1974,0x1967,0x195A,
			0x194D,0x193F,0x1932,0x1924,0x1916,
			0x1909,0x18FB,0x18ED,0x18DE,0x18D0,
			0x18C1,0x18B3,0x18A4,0x1895,0x1886,
			0x1877,0x1868,0x1858,0x1849,0x1839,
			0x1829,0x1819,0x1809,0x17F9,0x17E8,
			0x17D8,0x17C7,0x17B6,0x17A5,0x1793};

void hum_display(void)				//  ÷ Լ
{
	unsigned char i, hum=0, temp;
	unsigned int freq_h, freq_l, frequency;

	freq_h=TH0;
	freq_l=TL0;
	frequency=freq_h<<8;
	frequency=frequency | freq_l;

	for (i=0; i <= 99; i++) {
		if (frequency >= hum_table[i])	// ȯǥκ  
		break;
		hum++;
		if (hum==0x0a) hum=0x10;	// BCD ȯ
		else if (hum==0x1a) hum=0x20;
		else if (hum==0x2a) hum=0x30;
		else if (hum==0x3a) hum=0x40;
		else if (hum==0x4a) hum=0x50;
		else if (hum==0x5a) hum=0x60;
		else if (hum==0x6a) hum=0x70;
		else if (hum==0x7a) hum=0x80;
		else if (hum==0x8a) hum=0x90;
		else if (hum==0x9a) hum=0x00;
	}

	temp=hum;
	temp=temp>>4;
	temp=temp | 0x30;
	P1=temp;		// 10   ÷
	unit_10=0;		// 4511 ͸ ġ
	unit_10=1;

	temp=hum & 0x0f;
	temp=temp | 0x30;
	P1=temp;		// 1   ÷
	unit_01=0;		// 4511 ͸ ġ
	unit_01=1;
}

void TMR1_int(void) interrupt 3	// Ÿ̸/ī 1 ͷƮ  ȣ = 3
{
	EA=0;			// ͷƮ 𽺿̺
	count--;
	if (count==0) {		// 1 ˻
		hum_display();	//   ÷
		TH0=0x00;	// ī =0
		TL0=0x00;
		count=20;	// ݺ
	}
	TH1=0x3c;		//  缳(0.05)
	TL1=0xb0;
	EA=1;			// ͷƮ ο̺
	return;
}

void main(void)
{
	count=20;	// ݺ (20x0.05=1)
	TMOD=0x15;	// Ÿ̸/ī1(Ÿ̸  1), Ÿ̸/ī0(ī  1)
	TH1=0x3c;	//  (0.05)
	TL1=0xb0;	// 65536-50000=3CB0H
	TH0=0x00;	// ī ʱ갪=0000H
	TL0=0x00;

	ET1=1;		// Ÿ̸ 1 ͷƮ ο̺
	ET0=1;		// ī 0 ͷƮ ο̺
	EA=1;		// ü ͷƮ ο̺
	TR1=1;		// Ÿ̸ 1 run
	TR0=1;		// Ÿ̸ 0 run
	while(1);	// ͷƮ 
}
